<bugID>961823<Summary>Australis Customize mode breaks tab paradigm. Consider suggested alternatives.</Summary><Description>This bug is for discussing possible alternatives to the current Australis Customize mode. If we want to discuss it, I suggest to first focus on the UI design. If we can come up with a better design than the current one, then we could also assess its engineering complexity and take it into account as well.

I understand that right now it's a bit late to change paradigms, but maybe we could do it as a later phase. I also understand there are already plans in place to unify the customize tab with the addons tab. This will have to be addressed if we change customize mode.

My main concern with the current customize mode is that IMO it breaks the tab paradigm, and therefore behaves unexpectedly.

Current customize tab is a "magic tab". When this tab is selected:
- It alters (shrinks) the whole browser layout.
- Icons could be moved around the UI (inside or outside the tab "container").
- Existing icons don't behave as they usually do (e.g. clicking them doesn't do anything).
- When another "normal" tab is clicked, the browser goes back to "normal", and then if the customize tab is clicked, the browser goes again into "magic" mode.

All those break the tab paradigm IMP, where the tab is a container, and its scope is visually confined to a known area. But selecting the customize tab unexpectedly alters the browser behavior.

I think that if we have Customize "mode", then a special tab is not the correct container for it.

One alternative is the behavior pre-Australis, where it's still a mode, but using a modal dialog rather than contained in a tab.

Here are two more suggestions:

1. Instead of inside a tab, the customize items extend from the config menu doorhanger (to the left side with the default layout) and cover most of the browser "content" area, but "attached and extend" the config menu. This way they're clearly part of the config menu. No need to shrink the browser and put the mode in a tab. We could make the mode more noticeable (and especially that we can't click icons etc) by visual indication to the customizable icons, e.g. maybe add border to all moveable icons, or overlay a "handle" to each moveable icon, etc. Pressing ESC or clicking anywhere outside the extended config menu doorhanger will close it and exit customize mode (either back to the normal config menu, or just close the menu completely). Dragging configurable icons outside/inside the config menu will not close the menu.

2. Much less "special" mode - if icons are unlocked (checkbox at the config menu doorhanger) then they can be moved around at any time, regardless if the config menu is open. If it is open, then icons could be moved also to or from it. To access the invisible icons, the config menu doorhanger could have a "more" drawer which, when open, still doesn't alter the above behavior (i.e. icons are clickable and, if unlocked, also moveable). Since there's no special browser mode anymore, the "more" drawer will also contain other UI options which belong to "customize", such as toolbar selection checkboxes, draw in titlebar checkbox, etc.

If we wish to discourage users from keeping in "working but unlocked icons mode" (with suggestion 2 above), we could add some visual indication, such as overlayed handle to all icons, or border, etc, which will remind users the icons are not locked in place.

I don't claim that these suggestions are complete or without faults, but hopefully this bug could be used as a starting point to improve the current Australis customize tab/mode.</Description></bugID>